Index: branches/proxy/src/lib/network/handshake.h
===================================================================
--- branches/proxy/src/lib/network/handshake.h	(revision 9346)
+++ branches/proxy/src/lib/network/handshake.h	(revision 9347)
@@ -1,5 +1,9 @@
 /*!
  * @file network_stream.h
- *  implementation of a network pipe
+ *  implementation of a network pipe. This node handles the handshake of two network nodes and exchanges informationas
+ * vial to the connection setup.
+ *
+ * the local node only writes in the localState variable. the remoteState variable will be written from the remote network node
+ * so don't write into it!
  */
 
@@ -8,61 +12,107 @@
 
 #include "base_object.h"
+#include "ip.h"
 #include "synchronizeable.h"
 
-#define _ORXONOX_ID 0xF91337A0
+//!< a struct to save the handshakes to
+struct HandshakeState
+{
+  int           orxId;                         //!< orxonox id
+  int           version;                       //!< network protocol version
 
-#define _ORXONOX_VERSION 1
+  int           networkManagerId;              //!< unique id of the network manager
+  int           messageManagerId;              //!< unique id of the message manager
+  int           hostId;                        //!< host id
+  int           nodeType;                      //!< type of the network node
 
-struct HandshakeState {
-  int orxId;
-  int version;
-  
-  int networkManagerId;
-  int messageManagerId;
-  int hostId;
-  
-  int completed;
-  int canDel;
-  
-  int error;
-  
-  std::string errorString;
-  
+  int           completed;                     //!< true if completed
+  int           canDel;                        //!< true if marked for deletion
+
+  int           error;                         //!< error number
+
+  std::string   errorString;                   //!< error string
+
   //additional data
-  std::string preferedNickName;
+  std::string   preferedNickName;              //!< prefered nick name
+
+  int           redirectProxy;                 //!< true if the client should reconnect to a proxy server (either 1 or 2 )
+  IP            proxy1;                        //!< ip address of the first proxy (0.0.0.0 of not available)
+  IP            proxy2;                        //!< ip address of the second proxy (0.0.0.0 of not available)
 };
 
+
+//!< the handshake itself with some interface functions
 class Handshake : public Synchronizeable
 {
+
   public:
-    Handshake( bool server, int clientId = 0, int networkGameManagerId = 0, int messageManagerId = 0 );
-    inline bool       completed(){ return localState.completed != 0 && remoteState.completed != 0; }
-    inline bool       ok(){ return localState.error == 0 && remoteState.error == 0; }
-    inline int        getHostId(){ return remoteState.hostId; }
-    inline int        getNetworkGameManagerId(){ return remoteState.networkManagerId; }
-    inline int        getMessageManagerId(){ return remoteState.messageManagerId; }
-    inline void       doReject( std::string reason ){ localState.error = 1; localState.errorString = "the server rejected your connection ["+ reason +"]"; }
-    inline bool       canDel(){ return localState.canDel == 1 && remoteState.canDel == 1; }
-    inline bool       allowDel(){ return localState.canDel == 1; }
-    inline void       del(){ localState.canDel = 1; }
-    
-    inline void       setPreferedNickName( const std::string & nick ){ localState.preferedNickName = nick; }
+    Handshake( int nodeType, int clientId = 0, int networkGameManagerId = 0, int messageManagerId = 0 );
+
+
+    /* functions indicating states of the handshake */
+    /** @returns true if the handshake is completed */
+    inline bool completed(){ return localState.completed != 0 && remoteState.completed != 0; }
+    /** @returns true if no error has occured until now */
+    inline bool ok(){ return localState.error == 0 && remoteState.error == 0; }
+    /** stops the handshake and reject the other side with @param reason: string describing the reason */
+    inline void doReject( std::string reason ){ localState.error = 1; localState.errorString = "the server rejected your connection ["+ reason +"]"; }
+    /** @returns true if the handshake is finished and the instances can be deleted */
+    inline bool canDel(){ return localState.canDel == 1 && remoteState.canDel == 1; }
+    /** @returns true if the local state can be removed*/
+    inline bool allowDel(){ return localState.canDel == 1; }
+    /** marks the handshake to be deleted */
+    inline void del(){ localState.canDel = 1; }
+
+
+    /* the actual informations exchanged in the handshake */
+    /** @returns the host id of the remote host */
+    inline int  getHostId(){ return remoteState.hostId; }
+    /** @returns the unique id of the network game manager*/
+    inline int  getNetworkGameManagerId(){ return remoteState.networkManagerId; }
+    /** @returns the unique id of the message manager */
+    inline int  getMessageManagerId(){ return remoteState.messageManagerId; }
+    /** @returns the node type of the remote host */
+    inline int getRemoteNodeType() { return this->remoteState.nodeType; }
+
+    /** sets @param nick the prefereded nick name */
+    inline void setPreferedNickName( const std::string & nick ){ localState.preferedNickName = nick; }
+    /** @returns the prefered nick name */
     inline std::string getPreferedNickName(){ return remoteState.preferedNickName; }
-    
+
+    /** @returns if true the local client should reconnect to a proxy server from the proxy server list */
+    inline bool redirect() { return this->remoteState.redirectProxy;}
+    /** @param flag: indicating if the client should be redirected */
+    inline void setRedirect(bool flag) { this->localState.redirectProxy = flag; }
+
+    /** @param address: the address of the proxy server 1 if any */
+    inline void setProxy1Address(IP address) { this->localState.proxy1 = address; }
+    /** @returns the address of the proxy server 1 if any */
+    inline IP getProxy1Address() { return this->remoteState.proxy1; }
+    /** @param address: the address of the proxy server 2 if any */
+    inline void setProxy2Address(IP address) { this->localState.proxy2 = address; }
+    /** @returns the address of the proxy server 2 if any */
+    inline IP getProxy2Address() { return this->remoteState.proxy2; }
+
+
+    /* variable handler function */
     virtual void varChangeHandler( std::list<int> & id );
 
+
   private:
-    HandshakeState localState;
-    HandshakeState remoteState;
-    
-    int netManId_handler;
-    int msgManId_handler;
-    int hostId_handler;
-    int completed_handler;
-    int error_handler;
-    int errorString_handler;
-    int orxId_handler;
-    int version_handler;
-    int candel_id;
+    HandshakeState     localState;                            //!< the local handshake state
+    HandshakeState     remoteState;                           //!< the remote handshake state
+
+    int                orxId_handler;                         //!< orxonox id handler
+    int                version_handler;                       //!< orxonox version id handler
+    int                netManId_handler;                      //!< network manager handler
+    int                msgManId_handler;                      //!< message manager handler
+    int                hostId_handler;                        //!< host id handler
+    int                nodeTypeHandler;                       //!< node type handler
+
+    int                completed_handler;                     //!< handshake completion handler
+    int                error_handler;                         //!< handshake error handler
+    int                errorString_handler;                   //!< handshake error string handler
+    int                candel_id;                             //!< handshake deletion handler
+    int                nodeType;                              //!, the type of the network node
 
 };
Index: branches/proxy/src/lib/network/ip.cc
===================================================================
--- branches/proxy/src/lib/network/ip.cc	(revision 9347)
+++ branches/proxy/src/lib/network/ip.cc	(revision 9347)
@@ -0,0 +1,276 @@
+/**
+ * @file ip.cc
+ * @brief A IP class, that handles IP names and resolution.
+ *
+ * code taken from audiere.
+ *
+ *
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Grauer
+ * co-programmer: Patrick Boenzli
+ */
+
+#include "ip.h"
+
+#include <iostream>
+
+#include "multi_type.h"
+#include "substring.h"
+
+/**
+ * @brief default constructor
+ */
+IP::IP()
+{
+  this->_ip = 0;
+  this->_port = IP::_defaultPort;
+}
+
+
+/**
+ * @brief constructor from ip and port
+ * @param ip the IP
+ * @param port the Port
+ * @return self
+ */
+IP::IP(int ip, int port)
+{
+  this->_ip = ip;
+  if (port != -1)
+    this->_port = port;
+  else
+    this->_port = IP::_defaultPort;
+}
+
+
+/**
+ * @brief constructor from a String
+ * @param ip the IP as a String.
+ * @param resolve if true, the IP is resolved via DNS,
+ * @return self
+ */
+IP::IP(const std::string& ip, bool resolve)
+{
+  *this = IP::stringToIP(ip, IP::_defaultPort, resolve);
+}
+
+/**
+ * @brief constructor from a String
+ * @param ip the IP as a String.
+ * @param port The port to be resolved.
+ * @param resolve if true, the IP is resolved via DNS,
+ * @return self
+ */
+IP::IP(const std::string& ip, int port, bool resolve)
+{
+  *this = IP::stringToIP(ip, port, resolve);
+}
+
+
+/**
+ * @brief constructor from an SDL net structure IPaddress
+ * @param ip the ip.
+ * @return self
+ */
+IP::IP(const IPaddress& ip)
+{
+  this->_ip = ip.host;
+  this->_port = ip.port;
+}
+
+
+/**
+ * @brief copy constructor.
+ * @param ip the IP to copy.
+ * @return self
+ */
+IP::IP(const IP& ip)
+{
+  *this = ip;
+}
+
+/**
+ * @brief copy operator
+ * @param ip the IP to copy.
+ * @return self.
+ */
+const IP& IP::operator=(const IP& ip)
+{
+  this->_ip = ip.host();
+  this->_port = ip.port();
+  return *this;
+}
+
+
+/**
+ * @brief copy operator
+ * @param ip the IP to copy.
+ * @return self.
+ */
+const IP& IP::operator=(const IPaddress& ip)
+{
+  this->_ip = ip.host;
+  this->_port = ip.port;
+  return *this;
+}
+
+
+/**
+ * @brief comparison operator
+ * @param ip the IP to compare
+ * @return true if ip _and_ port match.
+ */
+bool IP::operator==(const IP& ip)
+{
+  return (this->_ip == ip.host() &&
+          this->_port == ip.port());
+}
+
+
+/**
+ * @brief comparison operator
+ * @param ip the IP to compare
+ * @return true if ip _and_ port do not match.
+ */
+bool IP::operator!=(const IP& ip)
+{
+  return (this->_ip != ip.host() ||
+      this->_port != ip.port());
+}
+
+
+/**
+ * @brief converts a String into an IP Object.
+ * @param ip The string holding an IP.
+ * @param port The port to be resolved.
+ * @param resolve if true, the IP is resolved via DNS,
+ * otherwise (resolve == false) the IP is being transformed
+ * from a String (xxx.xxx.xxx.xxx) to an integer.
+ *
+ * @return A newly constructed IP.
+ */
+IP IP::stringToIP(const std::string& ip, int port, bool resolve)
+{
+  if (resolve)
+  {
+    IPaddress ipaddr;
+
+    SDLNet_ResolveHost(&ipaddr, NULL, 2000);
+
+    return IP(ipaddr.host, port);
+  }
+  else
+  {
+    SubString ipaddr(ip, '.');
+    if(ip.size() != 4 )
+      return IP();
+
+    MultiType part0(ipaddr[0]);
+    MultiType part1(ipaddr[1]);
+    MultiType part2(ipaddr[2]);
+    MultiType part3(ipaddr[3]);
+
+    int addr = (part0.getInt() << 24) +
+               (part1.getInt() << 16) +
+               (part2.getInt() <<  8) +
+               part3.getInt();
+    return IP(addr, port);
+  }
+}
+
+
+/**
+ * @brief if you want to have a specific part of an IP
+ * @param part the n'th part of the IP addr (splitted by '.').
+ * @return the amount held in the designated part.
+ */
+int IP::ipPart(unsigned int part) const
+{
+  switch (part)
+  {
+    case 0:
+      return  (_ip & 0xFF000000) >> 24;
+    case 1:
+      return  (_ip & 0x00FF0000) >> 16;
+    case 2:
+      return  (_ip & 0x0000FF00) >> 8;
+    case 3:
+      return  (_ip & 0x000000FF);
+    default:
+      return -1;
+  }
+}
+
+
+/**
+ * @return the Ip as a string.
+ */
+std::string IP::ipString() const
+{
+  return IP::ipToString(this->_ip, this->_port);
+}
+
+
+/**
+ * @brief converts an IPaddress struct into a String.
+ * @param ipaddr the IP address as a SDL_net struct.
+ * @return the string retrieved from the IP.
+ */
+std::string IP::ipToString(const IPaddress& ipaddr)
+{
+  int ip = SDLNet_Read32 (ipaddr.host);
+  return IP::ipToString(ip, ipaddr.port);
+}
+
+
+/**
+ * @brief converts a IP into a String (without port).
+ * @param ip the IP to put into the string.
+ * @param port -1 if not wanted
+ * @return the string of the ip.
+ */
+std::string IP::ipToString(int ip, int port)
+{
+  MultiType part0((int) (ip & 0xFF000000) >> 24);
+  MultiType part1((int) (ip & 0x00FF0000) >> 16);
+  MultiType part2((int) (ip & 0x0000FF00) >>  8);
+  MultiType part3((int) (ip & 0x000000FF) );
+
+  std::string addr = part3.getString() + "." + part2.getString() + "." +
+                     part1.getString() + "." + part0.getString();
+
+  if (port != -1)
+    addr += ":" + MultiType(port).getString();
+  return addr;
+}
+
+
+/// default port definition.
+short IP::_defaultPort = 9999;
+
+/**
+ * @brief if no IP is supplied this port is used, so that IP can be resolved usefully.
+ * @param defaultPort The default port.
+ */
+void IP::setDefaultPort(short defaultPort)
+{
+  IP::_defaultPort = defaultPort;
+}
+
+
+/**
+ * @brief print out the IP in a nice fashion
+ */
+void IP::debug() const
+{
+  std::cout << "IP is " << this->ipString() << std::endl;
+}
Index: branches/proxy/src/lib/network/ip.h
===================================================================
--- branches/proxy/src/lib/network/ip.h	(revision 9347)
+++ branches/proxy/src/lib/network/ip.h	(revision 9347)
@@ -0,0 +1,64 @@
+
+/*!
+ * @file ip.h
+ *
+ * @brief the ip class is used to transform strings to ip's and backwards
+ * it can also be used to
+ */
+
+#ifndef __IP_H__
+#define __IP_H__
+
+#include "netdefs.h"
+#include <string>
+
+
+
+//! A class to handle time itself
+class IP
+{
+  public:
+    /// CONSTRUCTORS
+    IP();
+    IP(int ip, int port);
+    IP(const std::string& ip, bool resolve = true);
+    IP(const std::string& ip, int port = -1, bool resolve = true);
+    IP(const IPaddress& ip);
+    IP(const IP& ip);
+
+    /// OPERATORS
+    const IP& operator=(const IP& ip);
+    const IP& operator=(const IPaddress& ip);
+    bool operator==(const IP& ip);
+    bool operator!=(const IP& up);
+
+    /// RETRIVEAL
+    /** @returns the IP */
+    int host() const { return this->_ip; };
+    /** @returns the Port */
+    short port() const { return this->_port; };
+    inline IPaddress getSDLNotation() { IPaddress sdlIP; sdlIP.host = this->_ip; sdlIP.port = this->_port; return sdlIP; }
+
+    int ipPart(unsigned int part) const;
+    std::string ipString() const;
+
+    void debug() const;
+
+  public:
+    /// SETUP
+    static IP stringToIP(const std::string& ip, int port = -1, bool resolve = true);
+
+    static std::string ipToString(const IPaddress& ipaddr);
+    static std::string ipToString(int ip, int port = -1);
+
+    static void setDefaultPort(short defaultPort);
+    static short defaultPort(short defaultPort) { return IP::_defaultPort; };
+
+  private:
+    int           _ip;           //!< The IP in int form.
+    short         _port;         //!< The Port number of the IP
+
+    static short  _defaultPort;  //!< Default Port
+};
+
+#endif /* __IP_H__ */
Index: branches/proxy/src/lib/network/message_manager.cc
===================================================================
--- branches/proxy/src/lib/network/message_manager.cc	(revision 9346)
+++ branches/proxy/src/lib/network/message_manager.cc	(revision 9347)
@@ -52,13 +52,13 @@
       }
     }
-    
+
     it->second.messages.clear();
     it->second.toAck.clear();
   }
-  
+
   messageQueue.clear();
-  
+
   this->messageHandlerMap.clear();
-  
+
   MessageManager::singletonRef = NULL;
 }
@@ -82,9 +82,9 @@
   int i = 0;
   int n;
-  
+
   n = Converter::intToByteArray( messageQueue[userId].toAck.size(), data + i, maxLength );
   i += n;
   assert( n == INTSIZE );
-  
+
   for ( std::list<int>::iterator it = messageQueue[userId].toAck.begin(); it != messageQueue[userId].toAck.end(); it++)
   {
@@ -93,11 +93,11 @@
     assert( n == INTSIZE );
   }
-  
+
   messageQueue[userId].toAck.clear();
-  
+
   n = Converter::intToByteArray( messageQueue[userId].messages.size(), data + i, maxLength );
   i += n;
   assert( n == INTSIZE );
-  
+
   for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end(); it++ )
   {
@@ -105,18 +105,18 @@
     i += n;
     assert( n == INTSIZE );
-    
+
     n = Converter::intToByteArray( it->number, data + i, maxLength );
     i += n;
     assert( n == INTSIZE );
-    
+
     n = Converter::intToByteArray( it->messageId, data + i, maxLength );
     i += n;
     assert( n == INTSIZE );
-    
+
     assert( i + it->length <= maxLength );
     memcpy( data + i, it->data, it->length );
     i += it->length;
   }
-  
+
   return i;
 }
@@ -136,16 +136,16 @@
   int i = 0;
   int n;
-  
+
   int nAcks;
-  
+
   assert( i + INTSIZE <= length );
   n = Converter::byteArrayToInt( data + i, &nAcks );
   assert( n == INTSIZE );
   i += n;
-  
+
   std::list<int> acks;
-  
+
   int number;
-  
+
   for ( int j = 0; j < nAcks; j++ )
   {
@@ -154,10 +154,10 @@
     assert( n == INTSIZE );
     i += n;
-    
+
     acks.push_back( number );
   }
-  
+
   int nMessages;
-  
+
   assert( i + INTSIZE <= length );
   n = Converter::byteArrayToInt( data + i, &nMessages );
@@ -166,5 +166,5 @@
 
   int messageLength, messageId;
-  
+
   for ( int j = 0; j < nMessages; j++ )
   {
@@ -173,18 +173,18 @@
     assert( n == INTSIZE );
     i += n;
-    
+
     assert( i + INTSIZE <= length );
     n = Converter::byteArrayToInt( data + i, &number );
     assert( n == INTSIZE );
     i += n;
-  
+
     assert( i + INTSIZE <= length );
     n = Converter::byteArrayToInt( data + i, &messageId );
     assert( n == INTSIZE );
     i += n;
-    
+
     if ( number > 0 )
       messageQueue[userId].toAck.push_back( number );
-    
+
     assert( i + messageLength <= length );
     assert( messageHandlerMap.find( (MessageId)messageId ) != messageHandlerMap.end() );
@@ -194,5 +194,5 @@
       {
         NetworkMessage msg;
-        
+
         msg.data = new byte[messageLength];
         memcpy( msg.data, data + i, messageLength );
@@ -200,5 +200,5 @@
         msg.messageId = (MessageId)messageId;
         msg.number = userId;
-        
+
         incomingMessageBuffer.push_back( msg );
       }
@@ -207,6 +207,6 @@
     i += messageLength;
   }
-  
-  
+
+
   //TODO maybe handle incomingMessage in tick function. else local messages will not be handled if no clients are connected
   for ( std::list<NetworkMessage>::iterator it = incomingMessageBuffer.begin(); it != incomingMessageBuffer.end();  )
@@ -223,5 +223,5 @@
     it++;
   }
-  
+
   //walk throu message queue and remove acked messages
   for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end();  )
@@ -236,5 +236,5 @@
     it++;
   }
-  
+
   //TODO find bether way. maybe with timestamp
   if ( messageQueue[userId].recievedMessages.size() > 1000 )
@@ -255,5 +255,5 @@
   if ( messageQueue.find( userId ) == messageQueue.end() )
     return;
-    
+
   for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end(); it++ )
   {
@@ -262,7 +262,7 @@
     it->data = NULL;
   }
-  
+
   messageQueue[userId].toAck.clear();
-  
+
   messageQueue.erase( userId );
 }
@@ -270,5 +270,5 @@
 /**
  * registers function to handle messages with id messageId. someData is passed to callbackfuntion
- * @param messageId message id to handle 
+ * @param messageId message id to handle
  * @param cb function pointer to callback function
  * @param someData this pointer is passed to callback function without modification
@@ -278,11 +278,11 @@
 {
   MessageHandler messageHandler;
-  
+
   messageHandler.cb = cb;
   messageHandler.messageId = messageId;
   messageHandler.someData = someData;
-  
+
   messageHandlerMap[messageId] = messageHandler;
-  
+
   return true;
 }
@@ -309,6 +309,6 @@
  * @param data pointer to data
  * @param dataLength length of data
- * @param recieverType 
- * @param reciever 
+ * @param recieverType
+ * @param reciever
  */
 void MessageManager::sendMessage( MessageId messageId, byte * data, int dataLength, RecieverType recieverType, int reciever, MessagePriority messagePriority )
@@ -316,10 +316,10 @@
   for ( MessageQueue::iterator it = messageQueue.begin(); it != messageQueue.end(); it++ )
   {
-    if ( 
+    if (
          recieverType == RT_ALL_ME ||
          recieverType == RT_ALL_NOT_ME ||
          recieverType == RT_USER && it->first == reciever ||
          recieverType == RT_NOT_USER && it->first != reciever ||
-         recieverType == RT_SERVER && getNetworkStream()->isUserServer( it->first )
+         recieverType == RT_SERVER && getNetworkStream()->isUserMasterServer( it->first )
        )
     {
@@ -336,5 +336,5 @@
     }
   }
-  
+
   if ( recieverType == RT_ALL_ME )
   {
Index: branches/proxy/src/lib/network/monitor/connection_monitor.cc
===================================================================
--- branches/proxy/src/lib/network/monitor/connection_monitor.cc	(revision 9347)
+++ branches/proxy/src/lib/network/monitor/connection_monitor.cc	(revision 9347)
@@ -0,0 +1,257 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+#include "connection_monitor.h"
+#include "network_log.h"
+
+#include <debug.h>
+#include <SDL/SDL.h>
+#include <string.h>
+
+/* using namespace std is default, this needs to be here */
+using namespace std;
+
+/**
+ * constructor
+ * @param userId user's id
+ */
+ConnectionMonitor::ConnectionMonitor( int userId )
+{
+  /* set the class id for the base object and add ist to class list*/
+  this->setClassID(CL_CONNECTION_MONITOR, "ConnectionMonitor");
+  
+  this->userId = userId;
+  this->ping = 0;
+  this->incomingUnzippedBandWidth = 0;
+  this->outgoingUnzippedBandWidth = 0;
+  this->incomingZippedBandWidth = 0;
+  this->outgoingZippedBandWidth = 0;
+  this->nIncomingPackets = 0;
+  this->nOutgoingPackets = 0;
+  this->nZIncomingPackets = 0;
+  this->nZOutgoingPackets = 0;
+  
+  this->lastPacketTick = 0;
+  this->lastPrintTick = 0;
+}
+
+/**
+ * deconstructor
+ */
+ConnectionMonitor::~ConnectionMonitor( )
+{
+}
+
+/**
+ * process unzipped outgoing packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ */
+void ConnectionMonitor::processUnzippedOutgoingPacket( int tick, byte * data, int length, int stateId )
+{
+  nOutgoingPackets++;
+  
+  // for ping calculation
+  sentStateTicks[stateId] = tick;
+  
+  // calculate bandwidth
+  outgoingUnzippedPacketHistory[tick] = length;
+  outgoingUnzippedBandWidth = calculateBandWidth( outgoingUnzippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UNZIPPED UPSTREAM: user: %d bandwidth %f\n", userId, outgoingUnzippedBandWidth );
+  
+  // count zero bytes
+  //int nZeroBytes = 0;
+  
+  //for ( int i = 0; i < length; i++ )
+  //  if ( data[i] == '\0' )
+  //    nZeroBytes++;
+  
+  //NETPRINTF(n)( "ZEROBYTES: %d (%f%%)\n", nZeroBytes, ((float)100)*nZeroBytes/length );
+}
+
+/**
+ * process unzipped incoming packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ * @param ackedState state which was acked by this packet
+ */
+void ConnectionMonitor::processUnzippedIncomingPacket( int tick, byte * data, int length, int stateId, int ackedState )
+{
+  nIncomingPackets++;
+  
+  lastPacketTick = tick;
+  
+  // calculate ping
+  if ( sentStateTicks.find( ackedState ) != sentStateTicks.end() )
+  {
+    ackDelay.push_back( tick - sentStateTicks[ackedState] );
+  }
+  
+  while ( sentStateTicks.begin() != sentStateTicks.end() && sentStateTicks.begin()->first <= ackedState )
+    sentStateTicks.erase( sentStateTicks.begin() );
+      
+  while ( ackDelay.size() > N_PACKETS_FOR_PING )
+    ackDelay.erase( ackDelay.begin() );
+      
+  ping = 0;
+      
+  for ( std::list<int>::iterator it = ackDelay.begin(); it != ackDelay.end(); it++ )
+    ping += *it;
+      
+  if ( ackDelay.size() == 0 )
+    ping = -1;
+  else
+    ping /= ackDelay.size();
+      
+  //NETPRINTF(n)("PING: user: %d ping: %d\n", userId, ping );
+  
+  // calculate bandwidth
+  incomingUnzippedPacketHistory[tick] = length;
+  incomingUnzippedBandWidth = calculateBandWidth( incomingUnzippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UNZIPPED DOWNSTREAM: user: %d bandwidth %f\n", userId, incomingUnzippedBandWidth );
+  
+}
+
+/**
+ * remove old packets
+ * @param packetHistory 
+ * @param tick 
+ */
+void ConnectionMonitor::removeOldPackets( std::map< int, int > & packetHistory, int tick )
+{
+  while ( packetHistory.begin()->first < tick - MSECS_TO_CALC_BWIDTH )
+    packetHistory.erase( packetHistory.begin() );
+}
+
+/**
+ * calculate bandwidth out of packethistory
+ * @param packetHistory packet history
+ * @param tick current tick from SDL_GetTicks
+ * @return bandwidth in bytes/sec
+ */
+float ConnectionMonitor::calculateBandWidth( std::map< int, int > & packetHistory, int tick )
+{
+  removeOldPackets( packetHistory, tick );
+  
+  float res = 0.0f;
+#if 0
+  for ( std::map<int,int>::iterator it = packetHistory.begin(); it != packetHistory.end(); it++ )
+  {
+    if ( it != packetHistory.begin() )
+      res += it->second;
+  }
+  
+  if ( packetHistory.size() <= 1 || tick - packetHistory.begin()->first == 0 )
+    res = 0.0f;
+  else
+    res /= (float)(tick - packetHistory.begin()->first);
+  
+  res *= 1000.0f;
+#endif
+
+  for ( std::map<int,int>::iterator it = packetHistory.begin(); it != packetHistory.end(); it++ )
+  {
+    res += it->second;
+  }
+  
+  if ( packetHistory.size() <= 1 )
+    res = 0.0f;
+  else
+    res /= (float)(tick - packetHistory.begin()->first);
+  
+  res *= 1000.0f;
+
+  return res;
+}
+
+
+/**
+ * process zipped outgoing packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ */
+void ConnectionMonitor::processZippedOutgoingPacket( int tick, byte * data, int length, int stateId )
+{
+  nZOutgoingPackets++;
+  
+  // calculate bandwidth
+  outgoingZippedPacketHistory[tick] = length;
+  outgoingZippedBandWidth = calculateBandWidth( outgoingZippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UPSTREAM: user: %d bandwidth %f nOutgoingPackets %d\n", userId, outgoingZippedBandWidth, nOutgoingPackets );
+
+  if ( lastPrintTick < tick-1000 )
+  {
+    printStatis();
+    lastPrintTick = tick;
+  }
+}
+
+
+/**
+ * process zipped incoming packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ * @param ackedState state which was acked by this packet
+ */
+void ConnectionMonitor::processZippedIncomingPacket( int tick, byte * data, int length )
+{
+  nZIncomingPackets++;
+  
+  // calculate bandwidth
+  incomingZippedPacketHistory[tick] = length;
+  incomingZippedBandWidth = calculateBandWidth( incomingZippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("DOWNSTREAM: user: %d bandwidth %f nIncomingPackets %d\n", userId, incomingZippedBandWidth, nIncomingPackets );
+  
+}
+
+
+/**
+ * check if client sent no packets for SECS_TO_TIMEOUT
+ * @return true if last packet recieved \< NOW() - SECS_TO_TIMEOUT
+ */
+bool ConnectionMonitor::hasTimedOut( )
+{
+  if ( lastPacketTick + SECS_TO_TIMEOUT*1000 < SDL_GetTicks() && nIncomingPackets > 0 )
+    return true;
+  
+  if ( nIncomingPackets == 0 && nOutgoingPackets >= NETWORK_FREQUENCY*SECS_TO_TIMEOUT )
+    return true;
+  
+  return false;
+}
+
+
+
+/**
+ * prints bandwith usage, ping and other important things to telnet-console
+ */
+void ConnectionMonitor::printStatis( )
+{
+  NETPRINT(n)("============NETWORKSTATS FOR USER %d============\n", userId);
+  NETPRINT(n)("PING = %d\n", ping );
+  NETPRINT(n)("BANDWIDTH: UP: %f (%f) DOWN %f (%f)\n", outgoingZippedBandWidth, outgoingUnzippedBandWidth, incomingZippedBandWidth, incomingUnzippedBandWidth);
+  NETPRINT(n)("PACKETS: RECIEVED %d; SENT %d\n", nIncomingPackets, nOutgoingPackets );
+  NETPRINT(n)("================================================\n");
+}
+
+
Index: branches/proxy/src/lib/network/monitor/connection_monitor.h
===================================================================
--- branches/proxy/src/lib/network/monitor/connection_monitor.h	(revision 9347)
+++ branches/proxy/src/lib/network/monitor/connection_monitor.h	(revision 9347)
@@ -0,0 +1,71 @@
+/*!
+ * @file connection_monitor.h
+    \brief provides information about the quality of a connection.
+ */
+
+#ifndef _CONNECTION_MONITOR_H
+#define _CONNECTION_MONITOR_H
+
+#include "base_object.h"
+#include "netdefs.h"
+
+#include <map>
+#include <list>
+
+#define N_PACKETS_FOR_PING 20
+#define MSECS_TO_CALC_BWIDTH 1000
+#define SECS_TO_TIMEOUT 30
+
+class ConnectionMonitor : virtual public BaseObject
+{
+  public:
+    ConnectionMonitor( int userId );
+    virtual ~ConnectionMonitor();
+
+    void processUnzippedOutgoingPacket( int tick, byte * data, int length, int stateId );
+    void processUnzippedIncomingPacket( int tick, byte * data, int length, int stateId, int ackedState );
+
+    void processZippedOutgoingPacket( int tick, byte * data, int length, int stateId );
+    void processZippedIncomingPacket( int tick, byte * data, int length );
+
+    void calculatePing();
+
+    bool hasTimedOut();
+
+    void printStatis();
+
+  private:
+    float calculateBandWidth( std::map<int,int> & packetHistory, int tick );
+    void removeOldPackets( std::map<int,int> & packetHistory, int tick );
+
+    int userId;       //!< user's id
+
+    std::map<int,int>   sentStateTicks;
+
+    std::map<int,int>   incomingUnzippedPacketHistory;
+    std::map<int,int>   outgoingUnzippedPacketHistory;
+
+    std::map<int,int>   incomingZippedPacketHistory;
+    std::map<int,int>   outgoingZippedPacketHistory;
+
+    std::list<int>      ackDelay;
+    int                 ping;
+
+    float               incomingUnzippedBandWidth;
+    float               outgoingUnzippedBandWidth;
+
+    float               incomingZippedBandWidth;
+    float               outgoingZippedBandWidth;
+
+    int                 nIncomingPackets;
+    int                 nOutgoingPackets;
+
+    int                 nZIncomingPackets;
+    int                 nZOutgoingPackets;
+
+    int                 lastPacketTick;
+
+    int                 lastPrintTick;
+  };
+
+#endif
